  // rev 2025-0227   
  //   RAZ_UART1_Buffer1(); // et arme interrupt UART RX
  //   __delay_ms(1000);    // sert de  delay de boucle principale   
       if(Flag_Buffer1==1)
       {
            CPrint("Recu :");
           //    Print(Buffer1);
          //  CRLF1();
            p0=&Buffer1[0];
	    Print(p0);
            CRLF1();
	   if ( (*(p0)=='H') && (*(p0+1)=='e') && ( *(p0+2)=='l') && ( *(p0+3)=='p') )
            {
            CPrint("\r\n Help Commandes :\r\n");
	    CPrint("Seuil alarme courrant en mA S=010  819 \r\n");
	    CPrint("Freq PWM5=x avec 1=32Khz ... 2=16Khz.. 3=8Khz ... 7=500Hz\r\n");
            CPrint("Consigne_Duty_PWM : CONS=0001  1023 \r\n");
	    CPrint("MODE  Rampe :  MOD=1 sinon MOD=0 =>usage de Consigne_Duty_PWM\r\n");
  //Print(Buffer1);  
	    CRLF1();
            p0=0 ;
            }
	    // seuil 
	    if ( ( *(p0)=='S') &&  (*(p0+1)=='=') && (strlen(p0)==5) )
	    {  
		cx=*(p0+2)-48;
		k=(uint16_t)cx*100;
		cx=*(p0+3)-48;
		k= k+ (uint16_t)cx*10;
		cx=*(p0+4)-48;
		k= k+ cx;
		if ((k>9) && (k<820))
		{
		k=k *40; 
		 sprintf(CRam1,"seuil k= %5d  ",k);
                Print(CRam1);
		
		INT0IE=0;
		CPrint(" Sauve valeur dans  MASK_EN_REG register 07h \r\n");
		// 0x4E20 pour 20.000  500mA     avec 2 lampe 5W 12V en //
		// 0x2710 pour 10000 250mA       1 seule lampe 5W 12V 
		// 0x3A98 pour 16000 375mA
		// 0x0FA0 pour 4000 100mA
		tmp[0]=INA226_ALERT_LIMIT_REG;
		tmp[1]=(k >> 8);   // 4000 => 0FA0
		tmp[2]=(k & 0x00FF);
		Addr=INA226_ADDR;
		p1=&tmp[0];
		cx=3;
		I2C1_WriteNBytes(Addr, p1, cx);
	CPrint(" Relecture  valeur de MASK_EN_REG register 07h \r\n");
	Addr= INA226_ADDR;
        tmp[0]=0;
        tmp[1]=0;
        p1=&tmp[0];
        I2C1_ReadDataBlock(Addr,INA226_ALERT_LIMIT_REG, p1,3);
        k=(tmp[0]<<8) + tmp[1];
        Seuil_Alerte=  (float)k * 0.8192 / 32768;
        sprintf(CRam1," NEW Seuil d'alerte %3.3f Amperes\r\n",Seuil_Alerte);
        Print(CRam1);
	INT0IF=0;
	INT0IE=1;
        }//3
       p0=0; 
       }//1 
       if ( ( *(p0)=='P') &&  (*(p0+1)=='W') && (*(p0+2)=='M') && (*(p0+3)=='=')&& (strlen(p0)>3) )
	{  cx=*(p0+4)-48;
	    if ((cx>0) && (cx<8))
	    {
	        Choix_Freq_PWM=cx;
		T2CONbits.T2ON =0;
		sprintf(CRam1," CKPS= 0x%02X  Freq=%5d Hz\r\n",(int)cx,PWM5_Freq[ Choix_Freq_PWM]);
		Print(CRam1);
                //PIE4bits.TMR2IE=0;
		cx=cx<<4;
	        T2CON=T2CON & 0x0F;
		T2CON=T2CON |cx ; // CKPS
		T2PR=250;
		T2TMR=0;
		PIR4bits.TMR2IF=0; 
		//PIE4bits.TMR2IE=1;
		T2CONbits.T2ON =1;   
		CRLF1();
	    }  
	 p0=0; 
	}
	 if ( ( *(p0)=='M') &&  (*(p0+1)=='O') && (*(p0+2)=='D') && (*(p0+3)=='=')&& (strlen(p0)>3) )
	{  cx=*(p0+4)-48;
	    if (cx==1)
	      Mode_Rampe=1;
	      else
	      Mode_Rampe=0;
	    CPrint("Mode Rampe = "); 
	    PrintChar(Mode_Rampe+48);
	    CRLF1();
	 p0=0; 
	}
	if ( ( *(p0)=='C') &&  (*(p0+1)=='O') && (*(p0+2)=='N') && (*(p0+3)=='S')&& (*(p0+4)=='=')&& (strlen(p0)>8) )
	{  
	  if( isdigit(*(p0+5)) && isdigit(*(p0+6)) && isdigit(*(p0+7)) && isdigit(*(p0+8))  )
	  {     k=0;
	        cx=*(p0+5)-48; 
		k=(int)cx * 1000;
		cx=*(p0+6)-48; ;
		k=k + (int) cx *100;
		cx=*(p0+7)-48; ;
		k=k + (int) cx*10;
		cx=*(p0+8)-48; ;
		k=k + cx;
		if ( ( k>0) & (k<1024) )
		{
		 Consigne_Duty_PWM=k;
	         sprintf(CRam1,"\r\n Nouvelle Consigne Duty PWM = %05d\r\n",Consigne_Duty_PWM); 
	        Print(CRam1);
		}
	    }
	    else
	    {
		CPrint(" err sur consigne Duty PWM\r\n");
	    }
	  CRLF1();
	   p0=0; 
	} 
	
	
  } //if flag  